long greg_to_julian (long greg)
{
  int t1,
      t2,
      mm,
      dd,
      yy,
      leap_year;
 
  mm = greg / 10000;
  dd = (greg / 100) % 100;
  yy = (greg % 100) + 1900;
  if (yy < 1957)
      yy += 100;
  t1 = dd + ((mm - 1) * 3057 + 50) / 100;
  leap_year = ((yy % 4) == 0);
  if (leap_year)
      {
        if (((yy % 100) == 0) &&
            ((yy % 400) != 0))
            leap_year = 0;
      }
  t2 = (leap_year ? 1 : 0);
  if (mm > 2)
      t1 = t1 - 2 + t2;
  if ((mm > 12) ||
      (mm < 1)  ||
      (dd > 31) ||
      (dd < 1))
      return (0);
  else
      return(t1 + ((1000L * yy) % 100000));
}
 
long julian_to_greg (long julian)
{
  int t1,
      t2,
      mm,
      dd,
      yy,
      leap_year;
 
  yy = julian / 1000;
  if (yy < 100)
      if (yy > 56)
          yy += 1900;
      else
          yy += 2000;
  t1 = (julian % 1000) + 91;
  leap_year = ((yy % 4) == 0);
  if (leap_year)
      {
        if (((yy % 100) == 0) &&
            ((yy % 400) != 0))
            leap_year = 0;
      }
  t2 = (leap_year ? 1 : 0);
  if ((t1 - 150) > t2)
      t1 += 2 - t2;
  t2 = (t1 * 100) / 3055;
  mm = t2 - 2;
  dd = t1 - ((t2 * 3055) / 100);
  if ((mm > 12) ||
      (mm < 1)  ||
      (dd > 31) ||
      (dd < 1))
      return (0);
  else
      return ((mm * 10000L) + (dd * 100L) + (yy % 100L));
}
